//+------------------------------------------------------------------+
//|                                                 Strenght_USD.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+

#property copyright ""
#property link      ""
#property version   "1.00"
//#property strict
// ---------- Indicator Settings
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color2 Green
#property indicator_color1 Orange

#property indicator_width1 3
#property indicator_width2 2


#property indicator_maximum  100
#property indicator_minimum -100
#property indicator_level1     0
#property indicator_level2    25
#property indicator_level3   -25
#property indicator_level4    50
#property indicator_level5   -50

// ---- indicator parameters

extern int    FirstSmoothing   =25;
extern int    SecondSmoothing  =15;
extern int    Signal           = 9;


// ---- indicator buffers
double momentumBuffer[],momentumAbsBuffer[],
       Smoothing1Buffer[],Smoothing2Buffer[],Smoothing1AbsBuffer[],Smoothing2AbsBuffer[],
       SignalBuffer[],
       TSI[];
double p,p2;  



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
   p=0.0001;
   p2=0.01; 
   
   
   IndicatorBuffers(8);
   SetIndexBuffer(2,momentumBuffer);
   SetIndexBuffer(3,momentumAbsBuffer);
   SetIndexBuffer(4,Smoothing1Buffer);
   SetIndexBuffer(5,Smoothing2Buffer);
   SetIndexBuffer(6,Smoothing1AbsBuffer);
   SetIndexBuffer(7,Smoothing2AbsBuffer);
   
   
   SetIndexStyle (2,DRAW_NONE);
   SetIndexStyle (3,DRAW_NONE);
   SetIndexStyle (4,DRAW_NONE);
   SetIndexStyle (5,DRAW_NONE);
   SetIndexStyle (6,DRAW_NONE);
   SetIndexStyle (7,DRAW_NONE);
   
   SetIndexStyle (0,DRAW_LINE);
   SetIndexBuffer(0,TSI);
   SetIndexLabel (0,"Strenght_USD"); 
   
   SetIndexStyle (1,DRAW_LINE);
   SetIndexBuffer(1,SignalBuffer);
   SetIndexLabel (1,"Signal");
   
   SetIndexDrawBegin(0,FirstSmoothing+SecondSmoothing+1);
   SetIndexDrawBegin(1,FirstSmoothing+SecondSmoothing+Signal+1);
   
   IndicatorShortName("Strenght_USD" +"("+  FirstSmoothing+ ","+ SecondSmoothing+ ","+ Signal+")");
   
   //-----initiation done
   //return(INIT_SUCCEEDED);
   return(0);
  } 
   
   
  



//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
//---
   int limit,i;
   double momentum;
   int counted_bars=IndicatorCounted();// --- last counted bar will be recounted
   if (counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   // -------- Momentum Buffer
   
  for (  i=0; i<limit; i++)
       { momentum= -(iClose("NZDUSD",Period(),i)- iOpen("NZDUSD",Period(),i))/p +
                   -(iClose("EURUSD",Period(),i)- iOpen("EURUSD",Period(),i))/p +
                   -(iClose("GBPUSD",Period(),i)- iOpen("GBPUSD",Period(),i))/p +
                   -(iClose("AUDUSD",Period(),i)- iOpen("AUDUSD",Period(),i))/p +
                    (iClose("USDCAD",Period(),i)- iOpen("USDCAD",Period(),i))/p + 
                    (iClose("USDJPY",Period(),i)- iOpen("USDJPY",Period(),i))/p2 +
                    (iClose("USDCHF",Period(),i)- iOpen("USDCHF",Period(),i))/p ;
              
         if (IsTesting()==true)
           {
             if (iClose("NZDUSD",Period(),i)==0 || iClose("NZDUSD",Period(),i)== EMPTY_VALUE) momentum=0;
             if (iClose("EURUSD",Period(),i)==0 || iClose("EURUSD",Period(),i)== EMPTY_VALUE) momentum=0;
             if (iClose("GBPUSD",Period(),i)==0 || iClose("GBPUSD",Period(),i)== EMPTY_VALUE) momentum=0;
             if (iClose("AUDUSD",Period(),i)==0 || iClose("AUDUSD",Period(),i)== EMPTY_VALUE) momentum=0;
             if (iClose("USDCAD",Period(),i)==0 || iClose("USDCAD",Period(),i)== EMPTY_VALUE) momentum=0;
             if (iClose("USDJPY",Period(),i)==0 || iClose("USDJPY",Period(),i)== EMPTY_VALUE) momentum=0;
             if (iClose("USDCHF",Period(),i)==0 || iClose("USDCHF",Period(),i)== EMPTY_VALUE) momentum=0;
            }
         momentum=NormalizeDouble(momentum,0);
         momentumBuffer[i]  =momentum;
         momentumAbsBuffer[i]  =MathAbs(momentum); 
        }       
    
   for (  i=0; i<limit; i++)
       {  Smoothing1Buffer[i]   =iMAOnArray(momentumBuffer,0,FirstSmoothing,0,MODE_EMA,i);
          Smoothing1AbsBuffer[i]=iMAOnArray(momentumAbsBuffer,0,FirstSmoothing,0,MODE_EMA,i);
        }
        
   for (  i=0; i<limit; i++)
       {  Smoothing2Buffer[i]   =iMAOnArray(Smoothing1Buffer,0,SecondSmoothing,0,MODE_EMA,i);
          Smoothing2AbsBuffer[i]=iMAOnArray(Smoothing1AbsBuffer,0,SecondSmoothing,0,MODE_EMA,i);
       
        }
   for (  i=0; i<limit; i++)
       {  if (Smoothing2AbsBuffer[i]!=0)
              TSI[i] = 100 *Smoothing2Buffer[i]/Smoothing2AbsBuffer[i];
        }     
        
   for (  i=0; i<limit; i++)
       {  SignalBuffer[i]=iMAOnArray(TSI,0,Signal,0,MODE_EMA,i);
        }     
        
             

   return(0);
  }
//+------------------------------------------------------------------+

